Qwt User's Guide 6.1.1

- Main Page
- Related Pages
- Classes

- Class List
- Class Index
- Class Hierarchy
- Class Members

All Classes Functions Variables Typedefs Enumerations Enumerator Pages
Public Slots | Signals | Public Member Functions | Protected Member Functions | List of all members
QwtWheel Class Reference

The Wheel Widget. More...

`#include <qwt_wheel.h>`

Inheritance diagram for QwtWheel:
[legend]

## Public Slots
void | setValue (double)
| Set a new value without adjusting to the step raster. More...
void | setTotalAngle (double)
| Set the total angle which the wheel can be turned. More...
void | setViewAngle (double)
| Specify the visible portion of the wheel. More...
void | setMass (double)
| Set the slider's mass for flywheel effect. More...

## Signals
void | valueChanged (double value)
| Notify a change of value. More...
void | wheelPressed ()
void | wheelReleased ()
void | wheelMoved (double value)

## Public Member Functions
| QwtWheel (QWidget *parent=NULL)
| Constructor.
virtual | ~QwtWheel ()
| Destructor.
double | value () const
void | setOrientation (Qt::Orientation)
| Set the wheel's orientation. More...
Qt::Orientation | orientation () const
double | totalAngle () const
double | viewAngle () const
void | setTickCount (int)
| Adjust the number of grooves in the wheel's surface. More...
int | tickCount () const
void | setWheelWidth (int)
| Set the width of the wheel. More...
int | wheelWidth () const
void | setWheelBorderWidth (int)
| Set the wheel border width of the wheel. More...
int | wheelBorderWidth () const
void | setBorderWidth (int)
| Set the border width. More...
int | borderWidth () const
void | setInverted (bool tf)
| En/Disable inverted appearance. More...
bool | isInverted () const
void | setWrapping (bool tf)
| En/Disable wrapping. More...
bool | wrapping () const
void | setSingleStep (double)
| Set the step size of the counter. More...
double | singleStep () const
void | setPageStepCount (int)
| Set the page step count. More...
int | pageStepCount () const
void | setStepAlignment (bool on)
| En/Disable step alignment. More...
bool | stepAlignment () const
void | setRange (double vmin, double vmax)
| Set the minimum and maximum values. More...
void | setMinimum (double min)
double | minimum () const
void | setMaximum (double max)
double | maximum () const
void | setUpdateInterval (int)
| Specify the update interval when the wheel is flying. More...
int | updateInterval () const
void | setTracking (bool enable)
| En/Disable tracking. More...
bool | isTracking () const
double | mass () const

## Protected Member Functions
virtual void | paintEvent (QPaintEvent *)
| Qt Paint Event. More...
virtual void | mousePressEvent (QMouseEvent *)
| Mouse press event handler. More...
virtual void | mouseReleaseEvent (QMouseEvent *)
| Mouse Release Event handler. More...
virtual void | mouseMoveEvent (QMouseEvent *)
| Mouse Move Event handler. More...
virtual void | keyPressEvent (QKeyEvent *)
virtual void | wheelEvent (QWheelEvent *)
| Handle wheel events. More...
virtual void | timerEvent (QTimerEvent *)
| Qt timer event. More...
void | stopFlying ()
| Stop the flying movement of the wheel.
QRect | wheelRect () const
virtual QSize | sizeHint () const
virtual QSize | minimumSizeHint () const
virtual void | drawTicks (QPainter *, const QRectF &)
virtual void | drawWheelBackground (QPainter *, const QRectF &)
virtual double | valueAt (const QPoint &) const

## Detailed Description

The Wheel Widget.

The wheel widget can be used to change values over a very large range in very small steps. Using the setMass() member, it can be configured as a flying wheel.

The default range of the wheel is [0.0, 100.0]

See Also
  The radio example.

## Member Function Documentation

int QwtWheel::borderWidth | ( |  | ) | const

Returns
  Border width

See Also
  setBorderWidth()

void QwtWheel::drawTicks | ( | QPainter * | painter,
|  | const QRectF & | rect
| ) |  |
| protected virtual

Draw the Wheel's ticks

Parameters

  painter | Painter
  rect | Geometry for the wheel

void QwtWheel::drawWheelBackground | ( | QPainter * | painter,
|  | const QRectF & | rect
| ) |  |
| protected virtual

Draw the Wheel's background gradient

Parameters

  painter | Painter
  rect | Geometry for the wheel

bool QwtWheel::isInverted | ( |  | ) | const

Returns
  True, when the wheel is inverted

See Also
  setInverted()

bool QwtWheel::isTracking | ( |  | ) | const

Returns
  True, when tracking is enabled

See Also
  setTracking(), valueChanged(), wheelMoved()

void QwtWheel::keyPressEvent | ( | QKeyEvent * | event | ) |
| protected virtual

Handle key events

- Qt::Key_Home
  Step to minimum()
- Qt::Key_End
  Step to maximum()
- Qt::Key_Up
  In case of a horizontal or not inverted vertical wheel the value will be incremented by the step size. For an inverted vertical wheel the value will be decremented by the step size.
- Qt::Key_Down
  In case of a horizontal or not inverted vertical wheel the value will be decremented by the step size. For an inverted vertical wheel the value will be incremented by the step size.
- Qt::Key_PageUp
  The value will be incremented by pageStepSize() * singleStepSize().
- Qt::Key_PageDown
  The value will be decremented by pageStepSize() * singleStepSize().

Parameters

  event | Key event

double QwtWheel::mass | ( |  | ) | const

Returns
  mass

See Also
  setMass()

double QwtWheel::maximum | ( |  | ) | const

Returns
  The maximum of the range

See Also
  setRange(), setMaximum(), minimum()

double QwtWheel::minimum | ( |  | ) | const

Returns
  The minimum of the range

See Also
  setRange(), setMinimum(), maximum()

QSize QwtWheel::minimumSizeHint | ( |  | ) | const
| protected virtual

Returns
  Minimum size hint

Warning
  The return value is based on the wheel width.

void QwtWheel::mouseMoveEvent | ( | QMouseEvent * | event | ) |
| protected virtual

Mouse Move Event handler.

Turn the wheel according to the mouse position

Parameters

  event | Mouse event

void QwtWheel::mousePressEvent | ( | QMouseEvent * | event | ) |
| protected virtual

Mouse press event handler.

Start movement of the wheel.

Parameters

  event | Mouse event

void QwtWheel::mouseReleaseEvent | ( | QMouseEvent * | event | ) |
| protected virtual

Mouse Release Event handler.

When the wheel has no mass the movement of the wheel stops, otherwise it starts flying.

Parameters

  event | Mouse event

Qt::Orientation QwtWheel::orientation | ( |  | ) | const

Returns
  Orientation

See Also
  setOrientation()

int QwtWheel::pageStepCount | ( |  | ) | const

Returns
  Page step count

See Also
  setPageStepCount(), singleStep()

void QwtWheel::paintEvent | ( | QPaintEvent * | event | ) |
| protected virtual

Qt Paint Event.

Parameters

  event | Paint event

void QwtWheel::setBorderWidth | ( | int | width | ) |

Set the border width.

The border defaults to 2.

Parameters

  width | Border width

See Also
  borderWidth()

void QwtWheel::setInverted | ( | bool | on | ) |

En/Disable inverted appearance.

An inverted wheel increases its values in the opposite direction. The direction of an inverted horizontal wheel will be from right to left an inverted vertical wheel will increase from bottom to top.

Parameters

  on | En/Disable inverted appearance

See Also
  isInverted()

void QwtWheel::setMass | ( | double | mass | ) |
| slot

Set the slider's mass for flywheel effect.

If the slider's mass is greater then 0, it will continue to move after the mouse button has been released. Its speed decreases with time at a rate depending on the slider's mass. A large mass means that it will continue to move for a long time.

Derived widgets may overload this function to make it public.

Parameters

  mass | New mass in kg

See Also
  mass()

void QwtWheel::setMaximum | ( | double | value | ) |

Set the maximum value of the range

Parameters

  value | Maximum value

See Also
  setRange(), setMinimum(), maximum()

void QwtWheel::setMinimum | ( | double | value | ) |

Set the minimum value of the range

Parameters

  value | Minimum value

See Also
  setRange(), setMaximum(), minimum()

Note
  The maximum is adjusted if necessary to ensure that the range remains valid.

void QwtWheel::setOrientation | ( | Qt::Orientation | orientation | ) |

Set the wheel's orientation.

The default orientation is Qt::Horizontal.

Parameters

  orientation | Qt::Horizontal or Qt::Vertical.

See Also
  orientation()

void QwtWheel::setPageStepCount | ( | int | count | ) |

Set the page step count.

pageStepCount is a multiplicator for the single step size that typically corresponds to the user pressing PageUp or PageDown.

A value of 0 disables page stepping.

The default value is 1.

Parameters

  count | Multiplicator for the single step size

See Also
  pageStepCount(), setSingleStep()

void QwtWheel::setRange | ( | double | min,
|  | double | max
| ) |  |

Set the minimum and maximum values.

The maximum is adjusted if necessary to ensure that the range remains valid. The value might be modified to be inside of the range.

Parameters

  min | Minimum value
  max | Maximum value

See Also
  minimum(), maximum()

void QwtWheel::setSingleStep | ( | double | stepSize | ) |

Set the step size of the counter.

A value <= 0.0 disables stepping

Parameters

  stepSize | Single step size

See Also
  singleStep(), setPageStepCount()

void QwtWheel::setStepAlignment | ( | bool | on | ) |

En/Disable step alignment.

When step alignment is enabled value changes initiated by user input ( mouse, keyboard, wheel ) are aligned to the multiples of the single step.

Parameters

  on | On/Off

See Also
  stepAlignment(), setSingleStep()

void QwtWheel::setTickCount | ( | int | count | ) |

Adjust the number of grooves in the wheel's surface.

The number of grooves is limited to 6 <= count <= 50. Values outside this range will be clipped. The default value is 10.

Parameters

  count | Number of grooves per 360 degrees

See Also
  tickCount()

void QwtWheel::setTotalAngle | ( | double | angle | ) |
| slot

Set the total angle which the wheel can be turned.

One full turn of the wheel corresponds to an angle of 360 degrees. A total angle of n*360 degrees means that the wheel has to be turned n times around its axis to get from the minimum value to the maximum value.

The default setting of the total angle is 360 degrees.

Parameters

  angle | total angle in degrees

See Also
  totalAngle()

void QwtWheel::setTracking | ( | bool | enable | ) |

En/Disable tracking.

If tracking is enabled (the default), the wheel emits the valueChanged() signal while the wheel is moving. If tracking is disabled, the wheel emits the valueChanged() signal only when the wheel movement is terminated.

The wheelMoved() signal is emitted regardless id tracking is enabled or not.

Parameters

  enable | On/Off

See Also
  isTracking()

void QwtWheel::setUpdateInterval | ( | int | interval | ) |

Specify the update interval when the wheel is flying.

Default and minimum value is 50 ms.

Parameters

  interval | Interval in milliseconds

See Also
  updateInterval(), setMass(), setTracking()

void QwtWheel::setValue | ( | double | value | ) |
| slot

Set a new value without adjusting to the step raster.

Parameters

  value | New value

See Also
  value(), valueChanged()

Warning
  The value is clipped when it lies outside the range.

void QwtWheel::setViewAngle | ( | double | angle | ) |
| slot

Specify the visible portion of the wheel.

You may use this function for fine-tuning the appearance of the wheel. The default value is 175 degrees. The value is limited from 10 to 175 degrees.

Parameters

  angle | Visible angle in degrees

See Also
  viewAngle(), setTotalAngle()

void QwtWheel::setWheelBorderWidth | ( | int | borderWidth | ) |

Set the wheel border width of the wheel.

The wheel border must not be smaller than 1 and is limited in dependence on the wheel's size. Values outside the allowed range will be clipped.

The wheel border defaults to 2.

Parameters

  borderWidth | Border width

See Also
  internalBorder()

void QwtWheel::setWheelWidth | ( | int | width | ) |

Set the width of the wheel.

Corresponds to the wheel height for horizontal orientation, and the wheel width for vertical orientation.

Parameters

  width | the wheel's width

See Also
  wheelWidth()

void QwtWheel::setWrapping | ( | bool | on | ) |

En/Disable wrapping.

If wrapping is true stepping up from maximum() value will take you to the minimum() value and vice versa.

Parameters

  on | En/Disable wrapping

See Also
  wrapping()

double QwtWheel::singleStep | ( |  | ) | const

Returns
  Single step size

See Also
  setSingleStep()

QSize QwtWheel::sizeHint | ( |  | ) | const
| protected virtual

Returns
  a size hint

bool QwtWheel::stepAlignment | ( |  | ) | const

Returns
  True, when the step alignment is enabled

See Also
  setStepAlignment(), singleStep()

int QwtWheel::tickCount | ( |  | ) | const

Returns
  Number of grooves in the wheel's surface.

See Also
  setTickCnt()

void QwtWheel::timerEvent | ( | QTimerEvent * | event | ) |
| protected virtual

Qt timer event.

The flying wheel effect is implemented using a timer

Parameters

  event | Timer event

See Also
  updateInterval()

double QwtWheel::totalAngle | ( |  | ) | const

Returns
  Total angle which the wheel can be turned.

See Also
  setTotalAngle()

int QwtWheel::updateInterval | ( |  | ) | const

Returns
  Update interval when the wheel is flying

See Also
  setUpdateInterval(), mass(), isTracking()

double QwtWheel::value | ( |  | ) | const

Returns
  Current value of the wheel

See Also
  setValue(), valueChanged()

double QwtWheel::valueAt | ( | const QPoint & | pos | ) | const
| protected virtual

Determine the value corresponding to a specified point

Parameters

  pos | Position

Returns
  Value corresponding to pos

void QwtWheel::valueChanged | ( | double | value | ) |
| signal

Notify a change of value.

When tracking is enabled this signal will be emitted every time the value changes.

Parameters

  value | new value

See Also
  setTracking()

double QwtWheel::viewAngle | ( |  | ) | const

Returns
  Visible portion of the wheel

See Also
  setViewAngle(), totalAngle()

int QwtWheel::wheelBorderWidth | ( |  | ) | const

Returns
  Wheel border width

See Also
  setWheelBorderWidth()

void QwtWheel::wheelEvent | ( | QWheelEvent * | event | ) |
| protected virtual

Handle wheel events.

In/Decrement the value

Parameters

  event | Wheel event

void QwtWheel::wheelMoved | ( | double | value | ) |
| signal

This signal is emitted when the user moves the wheel with the mouse.

Parameters

  value | new value

void QwtWheel::wheelPressed | ( |  | ) |
| signal

This signal is emitted when the user presses the the wheel with the mouse

QRect QwtWheel::wheelRect | ( |  | ) | const
| protected

Returns
  Rectangle of the wheel without the outer border

void QwtWheel::wheelReleased | ( |  | ) |
| signal

This signal is emitted when the user releases the mouse

int QwtWheel::wheelWidth | ( |  | ) | const

Returns
  Width of the wheel

See Also
  setWheelWidth()

bool QwtWheel::wrapping | ( |  | ) | const

Returns
  True, when wrapping is set

See Also
  setWrapping()